#ifndef _APP_CONTROLLER_H
#define _APP_CONTROLLER_H

#include "imageProjection.h"
#include "laserTracking.h"
#include "guiSettingsManager.h"
#include "beoGui.h"

#define HOST "localhost"
#define SENDING_PORT 57120
#define	RECEIVING_PORT 12345

//#define PORT 57120
#define PROJECTION_W 640

class appController{

	public:

		appController();
	
		void setup();
		void update();
		void draw();

		void keyPressed(int key);
		void keyReleased(int key);

		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);

		void loadSettings();
		void saveSettings();
		void reloadSettings();

	private:
	
		void trackLaser();
		void checkBgui();

		ofImage background;
		
		imageProjection		IP;
		guiSettingsManager	GUI;
		laserTracking		LT;
		beoGui				BGUI;
		
		bool letDrawGui, previewWarp;

};

#endif