#ifndef _AREA_H
#define _AREA_H

#include "ofMain.h"
#include "ofxVectorMath.h"
#include "segment.h"

#define AREARESOLUTION 500		// in milliseconds
#define LINERESOLUTION 200		// in milliseconds

class area{

	public:
	
		area();

		void create(ofxPoint2f _lPos, float _aresol);
		void build(ofxPoint2f _lPos);
		void finishBuilding();
		void setAreaVertex(ofxPoint2f _lPos);
		void setLineVertex(ofxPoint2f _lPos);
		bool isLaserOver(ofxPoint2f _lp);
		
		segment * getSegmentList();
		
		void moveArea(ofxPoint2f laserPosition);
		void deleteArea();
		
		void drawCreationLine(ofxPoint2f _lPos);
		void draw();
		
		int getMaxX();
		int getMinX();
		int getMaxY();
		int getMinY();
		int getNumAreaVertex();
		ofxPoint2f getAreaVertex(int _i);
		
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);

		int			numOfSegments;
		
	private:
	
		void setSurroundingBox(ofxPoint2f _lPos);
		void updateSurroundingBox();
		
		vector <ofxPoint2f>		areaVertexList;
		vector <ofxPoint2f>		lineVertexList;
		segment *				segmentList;
		
		int			setAreaTimer;
		int			setLineTimer;
		int			maxX, minX, maxY, minY;
		ofxPoint2f	prevLasPos;
		bool		isFirstFrameOfMoveArea;
		
		//Handlers
		bool		movingHandler;
		int			handlerSelected;
		
		float		areaResolution;
		float		lineResolution;
};

#endif