/*
 *  beoGui.cpp
 *  openFrameworks
 *
 *  Created by berio molina on 4/18/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include "beoGui.h"

beoGui::beoGui(){
}

void beoGui::addScrollbar(string _n, int _x, int _y, float _mnv, 
						  float _mxv){
	barList.push_back(scrollbar());
	barList[barList.size()-1].setup(_x, _y, 80, 14, _mnv, _mxv, _n);
}

void beoGui::addButton(string _n, int _x, int _y, int _s){
	btnList.push_back(button());
	btnList[btnList.size()-1].setup(_x, _y, _s, _n);
}

void beoGui::addCheck(string _n, int _x, int _y, int _s){
	chkList.push_back(chek());
	chkList[chkList.size()-1].setup(_x, _y, _s, _n);
}

bool beoGui::hasChanged(string _n){
	for(int i = 0; i < barList.size(); i++){
		if(_n == barList[i].getName() ){
			return barList[i].getChanged();
		}
	}
	return false;
}

float beoGui::getF(string _n){
	for(int i = 0; i < barList.size(); i++){
		if(_n == barList[i].getName() ){
			return barList[i].getPos();
		}
	}
}

// Get Pressed
bool beoGui::getP(string _n){
	for(int i = 0; i < btnList.size(); i++){
		if(_n == btnList[i].getName() ){
			return btnList[i].getPressed();
		}
	}
}

// Get Checked
bool beoGui::getC(string _n){
	for(int i = 0; i < chkList.size(); i++){
		if(_n == chkList[i].getName() ){
			return chkList[i].getChecked();
		}
	}
}

void beoGui::draw(){
	for(int i=0; i<barList.size(); i++){
		barList[i].draw();
	}
	for(int i=0; i<btnList.size(); i++){
		btnList[i].draw();
	}
	for(int i=0; i<chkList.size(); i++){
		chkList[i].draw();
	}
}

void beoGui::mouseMoved(int x, int y ){
	for(int i=0; i<barList.size(); i++){
		barList[i].update(x, y);
	}
	for(int i=0; i<btnList.size(); i++){
		btnList[i].update(x, y);
	}
}

void beoGui::mouseDragged(int x, int y, int button){
	for(int i=0; i<barList.size(); i++){
		barList[i].update(x, y);
	}
}

void beoGui::mousePressed(int x, int y, int button){
	for(int i=0; i<barList.size(); i++){
		barList[i].press();
	}
	for(int i=0; i<btnList.size(); i++){
		btnList[i].press();
	}
	for(int i=0; i<chkList.size(); i++){
		chkList[i].press(x, y);
	}
}

void beoGui::mouseReleased(int x, int y, int button){
	for(int i=0; i<barList.size(); i++){
		barList[i].releas();
	}
	for(int i=0; i<btnList.size(); i++){
		btnList[i].release();
	}
}