#include "button.h"

button::button(){
}

void button::setup(int _x, int _y, int _s, string _n){
	pos.set(_x, _y);
	size = _s;
	name = _n;
	over = pressed = false;
	freeze = 0;
}

void button::update(int _x, int _y){
	if(_x > pos.x && _x < pos.x + size && 
	   _y > pos.y && _y < pos.y + size){
	   over = true;
	}else{
		over = false;
    }
}

bool button::press(){
    if(over){
		pressed = true;
		return true;
    }else{
		return false;
    }
}

void button::release(){
	pressed = false;
}

void button::draw(){
	ofSetColor(255, 255, 255);
    if(pressed){
		ofSetColor(102, 106, 110);
    }else if(over){
		ofSetColor(0, 0, 0);
    }else{
		ofSetColor(255, 255, 255);
    }
	ofFill();
	ofRect(pos.x, pos.y, size, size);
		
	ofSetColor(202, 162, 0);
	ofFill();
	ofRect(pos.x+size, pos.y, size/2, size);
	
	ofSetColor(255, 255, 255);
	ofDrawBitmapString(name, pos.x+size+size/2+2, pos.y+size-2);	
	
}

string button::getName(){
	return name;
}

bool button::getPressed(){
	return pressed;
}