#include "guiCheck.h"

guiCheck::guiCheck(){
	checked = false;	
}

guiCheck::guiCheck(int _x, int _y, int _cr, int _cg, int _cb, int _r, string _type){
				   
	set(_x, _y);
	cr = _cr;
	cg = _cg;
	cb = _cb;
	r = _r;
	type = _type;
	
	checked = false;
	pressDelay = 0;
}

void guiCheck::press(ofxPoint2f _lp, bool _cl){
	bool checkLaser = _cl;
	
	if(checkLaser){
		ofxPoint2f lp = _lp;
		if(distance(lp) < r*4){
			if(checked && ofGetElapsedTimeMillis()-pressDelay>1000){
				checked = false;
				pressDelay = ofGetElapsedTimeMillis();
			}else if(ofGetElapsedTimeMillis()-pressDelay>1000){
				checked = true;
				pressDelay = ofGetElapsedTimeMillis();
			}
		}
	}
}

void guiCheck::setChecked(bool _check){
	checked = _check;
}

bool guiCheck::getChecked(){
	return checked;
}

void guiCheck::draw(){
	if(checked){
		drawChecked();
	}

	if(type=="collision"){
		drawCollision(x, y);
	}else if(type=="mass"){
		drawMass(x, y);	
	}else if(type=="friction"){
		drawFriction(x, y);
	}
	
//	ofDrawBitmapString(type + " ball", x+37, y+2);
	ofDrawBitmapString(type + " ball", x-20, y+40);
}

void guiCheck::drawChecked(){
	ofEnableAlphaBlending();
	ofSetColor(200, 0, 30, 100);
		ofFill();
		ofCircle(x, y, r*4);
	ofEnableSmoothing();
		ofNoFill();
		ofCircle(x, y, r*4);
	ofDisableSmoothing();
	ofDisableAlphaBlending();
}

void guiCheck::drawCollision(float _x, float _y){
	ofSetColor(cr, cg, cb);
		ofFill();
		ofCircle(x, y, r-2);
	ofEnableSmoothing();
	ofSetLineWidth(1);
		ofNoFill();
		ofCircle(x, y, r-2);	

	ofSetLineWidth(2);
		ofNoFill();
		ofCircle(x, y, r*3);
	ofDisableSmoothing();
	
	ofFill();
}

void guiCheck::drawMass(float _x, float _y){
	ofSetColor(cr, cg, cb);
	ofSetLineWidth(1);
		ofFill();
		ofCircle(x, y, r);
	ofEnableSmoothing();
		ofNoFill();
		ofCircle(x, y, r);	
	ofDisableSmoothing();
	ofEnableAlphaBlending();
	ofSetColor(cr, cg, cb, 100);
		ofFill();
		ofCircle(x, y, r*5);

	ofDisableAlphaBlending();
}

void guiCheck::drawFriction(float _x, float _y){
	ofSetColor(cr, cg, cb);
	ofSetLineWidth(1);
		ofFill();
		ofCircle(x, y, r*2);
	ofEnableSmoothing();
		ofNoFill();
		ofCircle(x, y, r*2);	
	ofDisableSmoothing();
	ofEnableAlphaBlending();
		int dist=3;
		for(int i=0; i<10; i++){
			float alphaValue = ofMap(i, 0, 10, 155, 0);
			ofSetColor(cr, cg, cb, alphaValue);
		ofFill();
			ofCircle(x, y+i*dist, r*2);
		}
	ofDisableAlphaBlending();
}
