#include "guiRadio.h"

guiRadio::guiRadio(){
	checked = false;	
}

guiRadio::guiRadio(int _x, int _y, int _cr, int _cg, int _cb, int _r,
				   int _id, guiRadio * _oList, int _nor, string _name,
				   bool _eraser){
				   
	pos.set(_x, _y);
	cr = _cr;
	cg = _cg;
	cb = _cb;
	r = _r;
	myId = _id;
	othersList = _oList;	
	numOfRadios = _nor;
	eraser = _eraser;
	name = _name;

	checked = false;
}

bool guiRadio::press(ofxPoint2f _lp){
	ofxPoint2f lp = _lp;
	if(pos.distance(lp) < r*4){
		checked = true;
		
		for(int i=0; i<numOfRadios; i++){
			if(i!=myId){
				othersList[i].setChecked(false);
			}
		}
	}

}

void guiRadio::setChecked(bool _check){
	checked = _check;
}

bool guiRadio::getChecked(){
	return checked;
}

bool guiRadio::getEraser(){
	return eraser;
}

int * guiRadio::getColor(){
	int * color;
	color = new int[3];
	color[0] = cr;
	color[1] = cg;
	color[2] = cb;
	
	return color;
}

void guiRadio::draw(){
	ofSetColor(151, 103, 137);
//	ofDrawBitmapString(name, pos.x+37, pos.y+2);
	ofDrawBitmapString(name, pos.x-20, pos.y+40);
	
	ofSetLineWidth(1);
	if(checked){
		ofEnableAlphaBlending();
		ofSetColor(cr, cg, cb, 120);
		ofFill();
		ofCircle(pos.x, pos.y, r*4);
		ofEnableSmoothing();
		ofNoFill();
		ofCircle(pos.x, pos.y, r*4);
		ofDisableSmoothing();
		ofDisableAlphaBlending();
	}
	
	ofSetColor(cr, cg, cb);
	ofFill();
	ofCircle(pos.x, pos.y, r*2);
	ofEnableSmoothing();
	ofNoFill();
	ofCircle(pos.x, pos.y, r*2);
	ofDisableSmoothing();
	
	if(eraser){
		ofSetLineWidth(2);
		ofLine(pos.x-r*3, pos.y-r*3, pos.x+r*3, pos.y+r*3);
		ofLine(pos.x-r*3, pos.y+r*3, pos.x+r*3, pos.y-r*3);
		ofSetLineWidth(1);
	}
}