#ifndef _GUI_SETTINGS_MANAGER_H
#define _GUI_SETTINGS_MANAGER_H

#include "ofxXmlSettings.h"
#include "baseGui.h"
#include "guiSetting.h"

#define MAX_SETTINGS 100

class guiSettingsManager : public baseGui{

	public:
	
		guiSettingsManager();
	
		void readFromFile(string filePath);
		void addSetting(string displayName, string xmlName, int value, int min, int max, int incr);
		void addSetting(string displayName, string xmlName, float value, float min, float max, float incr);

		void updateValueFromXml(int which);
		void reloadSettings();
		void saveToFile(string filePath);

		int  getI(string varName);
		float getF(string varName);
		void setI(string varName, int val);
		void setF(string varName, float val);
		bool hasChanged(string varName);

		void selectNext();
		void selectPrev();
		void increase();
		void decrease();

		void drawAll(float x, float y, float spacing, float lineHeight);

	protected:
	
		ofxXmlSettings	xml;
		guiSetting 		gs[MAX_SETTINGS];
		bool			bI[MAX_SETTINGS];
		string 			handyString;
		int 			selected, index, whichSection;
};

#endif