#include "scrollbar.h"

scrollbar::scrollbar(){
}

void scrollbar::setup(int _x, int _y, int _w, int _h, float _mnv, 
				      float _mxv, string _name){
	pos.set(_x, _y);
	w = _w;
	h = _h;
	minVal = _mnv;
	maxVal = _mxv;
	p = pos.x + w/2 - h/2;
	pMin = pos.x;
	pMax = pos.x + w - h;
	name = _name;
	locked = false;
}

void scrollbar::update(int _x, int _y){
	if(over(_x, _y)){
		rollover = true;
    }else{
		rollover = false;
    }
    if(locked){
		p = MAX(pMin, MIN(_x-h/2, pMax));
		changed = true;
    }
}

void scrollbar::press(){
    if(rollover){
		locked = true;
    }else{
		locked = false;
    }
}

void scrollbar::releas(){
	locked = false;
}

bool scrollbar::over(int _x, int _y){
    if((_x > pos.x) && (_x < pos.x+w) && 
	   (_y > pos.y) && (_y < pos.y+h)){
		return true;
    }else{
		return false;
    }
}

void scrollbar::draw(){
	ofSetColor(255, 255, 255);
    ofFill();
    ofRect(pos.x, pos.y, w, h);
    if((rollover) || (locked)){
		ofSetColor(0, 0, 0);
    }else{
		ofSetColor(102, 106, 110);
    }
    ofRect(p, pos.y, h, h);
	ofSetColor(190, 140, 0);
    ofRect(pos.x+w, pos.y, 110, h);
	
	ofSetColor(255, 255, 255);
	ofDrawBitmapString(ofToString(getPos()), pos.x+w+5, pos.y+h-2);	
	ofSetColor(150, 150, 150);
	ofDrawBitmapString(name, pos.x+w+5+110, pos.y+h-2);	

}

float scrollbar::getPos(){
    float scalar = w/(w-h);
    float ratio = (p - pos.x) * scalar;
    float offset = minVal + (ratio/w * (maxVal-minVal));
    
	return offset;
}

//------------------------------------
bool scrollbar::getChanged(){
	
	bool rtnVal = false;
	
	if(changed){
		rtnVal  = true;
		changed = false;
	}

	return rtnVal;
}

string scrollbar::getName(){
	return name;
}