#include "tremor.h"

tremor::tremor(){
	kill = false;
}

void tremor::setup(float _x, float _y, int _r, int _cr, int _cg, int _cb){
	set(_x, _y);
	r = _r;
	duration = 500;
	time = ofGetElapsedTimeMillis();
	cr = _cr;
	cg = _cg;
	cb = _cb;
}

void tremor::update(float _x, float _y){
	set(_x, _y);
	int countUp = ofGetElapsedTimeMillis() - time;
	if(countUp > duration){
		kill = true;
	}else{
		alphaValue = ofMap(countUp, 0, duration, 255, 0);
		expandValue = ofMap(countUp, 0, duration, r, 0);
	}
}

bool tremor::getKillMe(){
	return kill;
}

void tremor::draw(){
	ofEnableAlphaBlending();
	ofSetColor(cr, cg, cb, alphaValue);
	ofFill();
	ofCircle(x, y, expandValue);
	ofDisableAlphaBlending();
}