#include "wave.h"

wave::wave(){
	kill = false;
}

void wave::setup(float _x, float _y, int _r, int _cYr, int _cYg, int _cYb){
	set(_x, _y);
	r = _r;
	duration = 1000;
	time = ofGetElapsedTimeMillis();
	cYr = _cYr;
	cYg = _cYg;
	cYb = _cYb;
}

void wave::update(float _x, float _y){
	ringPos.set(_x, _y);
	int countUp = ofGetElapsedTimeMillis() - time;
	if(countUp > duration){
		kill = true;
	}else{
		alphaValue = ofMap(countUp, 0, duration, 200, 0);
		expandValue = ofMap(countUp, 0, duration, r, r+15);
	}
}

bool wave::getKillMe(){
	return kill;
}

void wave::draw(){
	ofEnableAlphaBlending();
	ofSetColor(cYr, cYg, cYb, alphaValue);
	ofNoFill();
	ofCircle(x, y, expandValue);
	ofSetColor(cYr, cYg, cYb, alphaValue);
	ofFill();
	ofCircle(ringPos.x, ringPos.y, r+1);
	ofDisableAlphaBlending();
}